PRINT "Halloween Harry Extractor by Frenkel Smeijers, Version 1, 6-Sep-2004."
PRINT "Email: frenkel_smeijers@hotmail.com"
PRINT "Site: http://www.sfprod.tk"
PRINT

IF COMMAND$ = "" THEN
  PRINT "Usage: hhxtract [file to extract]"
  PRINT "Example: hhxtract harry.-0"
  END
END IF

OPEN COMMAND$ FOR BINARY AS #1
IF LOF(1) = 0 THEN
  PRINT "Can't find " + COMMAND$ + ". Make sure you've put this"
  PRINT "program in your Halloween Harry directory."
  CLOSE #1
  KILL COMMAND$
  END
END IF

CONST constbuffersize = 10000
DIM constbuffer AS STRING * constbuffersize

TYPE headertype
  idlen AS STRING * 1        '4
  id AS STRING * 4           '-ID-
  filenamelen AS STRING * 1  '<=12
  filename AS STRING * 12
  length AS LONG
END TYPE

DIM headeritem AS headertype

DO WHILE LOC(1) < LOF(1)

  GET #1, , headeritem
  IF headeritem.id <> "-ID-" THEN
    PRINT COMMAND$ + " has the wrong file format."
    GOTO einde
  END IF

  filename2$ = LEFT$(headeritem.filename, ASC(headeritem.filenamelen))

  OPEN filename2$ FOR BINARY AS #2

  extract% = &HFFFF 'TRUE
  IF LOF(2) > 0 THEN
    PRINT filename2$ + " already exists. Overwrite file (Y/N)? ";
    DO
      toets$ = INKEY$
    LOOP WHILE toets$ = ""
    PRINT toets$

    IF toets$ <> "n" AND toets$ <> "N" THEN
      CLOSE #2
      KILL filename2$
      OPEN filename2$ FOR BINARY AS #2
    ELSE
      extract% = 0  'FALSE
    END IF
  END IF

 
  IF extract% THEN
    'Do extract.
    length2& = headeritem.length
 
    'Get and put big chunks.
    DO WHILE length2& >= constbuffersize
      GET #1, , constbuffer
      PUT #2, , constbuffer
      length2& = length2& - constbuffersize
    LOOP
 
    'Get and put the last and little chunk.
    buffer$ = SPACE$(length2&)
    GET #1, , buffer$
    PUT #2, , buffer$
 
    PRINT filename2$ + " written."
 
  ELSE
    'Do not extract.
    SEEK #1, LOC(1) + headeritem.length + 1
  END IF
 
  CLOSE #2

LOOP

einde:
CLOSE #1
END

